/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.TipoDomicilio;
import com.rjconsultores.ventaboletos.service.TipoDomicilioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTipoDomicilioController")
@Scope("prototype")
public class EditarTipoDomicilioController extends MyGenericForwardComposer {

    @Autowired
    private TipoDomicilioService tipoDomicilioService;
    private TipoDomicilio tipoDomicilio;
    private MyListbox tipoDomicilioList;
    private Button btnApagar;
    private Textbox txtNome;
    BusquedaTipoDomicilioController busquedaTipoDomicilioController;
    private Textbox txtCve;
    private static Logger log = Logger.getLogger(EditarTipoDomicilioController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TipoDomicilio getTipoDomicilio() {
        return tipoDomicilio;
    }

    public void setTipoDomicilio(TipoDomicilio tipoDomicilio) {
        this.tipoDomicilio = tipoDomicilio;
    }

    public Textbox getTxtCve() {
        return txtCve;
    }

    public void setTxtCve(Textbox txtCve) {
        this.txtCve = txtCve;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        busquedaTipoDomicilioController = (BusquedaTipoDomicilioController) Executions.getCurrent().getArg().get("busquedaTipoDomicilioController");
        tipoDomicilio = (TipoDomicilio) Executions.getCurrent().getArg().get("tipoDomicilio");
        tipoDomicilioList = (MyListbox) Executions.getCurrent().getArg().get("tipoDomicilioList");


        if (tipoDomicilio.getTipodomicilioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        txtCve.getValue();

        try {
            tipoDomicilio.setActivo(Boolean.TRUE);
            tipoDomicilio.setFecmodif(Calendar.getInstance().getTime());
            tipoDomicilio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());


            List<TipoDomicilio> lsTipoDomiciolio =
                    tipoDomicilioService.buscar(tipoDomicilio.getDesctipo(),
                    tipoDomicilio.getCvetipodomicilio());

            boolean podeSalvar = false;
            if (lsTipoDomiciolio.isEmpty()) {
                podeSalvar = true;
            } else {
                if (tipoDomicilio.getTipodomicilioId() != null) {
                    for (TipoDomicilio p : lsTipoDomiciolio) {
                        if (p.getTipodomicilioId().equals(tipoDomicilio.getTipodomicilioId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            List<TipoDomicilio> lsTipoDomiciolioClave =
                    tipoDomicilioService.buscarClave(tipoDomicilio.getCvetipodomicilio());

            boolean podeSalvarClave = false;
            if (lsTipoDomiciolioClave.isEmpty()) {
                podeSalvarClave = true;
            } else {
                if (tipoDomicilio.getTipodomicilioId() != null) {
                    for (TipoDomicilio p : lsTipoDomiciolioClave) {
                        if (p.getTipodomicilioId().equals(tipoDomicilio.getTipodomicilioId())) {
                            podeSalvarClave = true;
                        }
                    }
                }
            }

            if (!podeSalvarClave) {
                Messagebox.show(
                        Labels.getLabel("editarTipoDomicilioController.MSG.clave"),
                        Labels.getLabel("editarTipoDomicilioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }
            if (!podeSalvar) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoDomicilioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (tipoDomicilio.getTipodomicilioId() == null) {
                    tipoDomicilioService.suscribir(tipoDomicilio);
                    tipoDomicilioList.addItem(tipoDomicilio);
                } else {
                    tipoDomicilioService.actualizacion(tipoDomicilio);
                    tipoDomicilioList.updateItem(tipoDomicilio);
                }

                Messagebox.show(
                        Labels.getLabel("editarTipoDomicilioController.MSG.suscribirOK"),
                        Labels.getLabel("editarTipoDomicilioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                busquedaTipoDomicilioController.refreshLista();
                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarTipoDomicilioController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoDomicilioController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoDomicilioController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTipoDomicilioController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                tipoDomicilioService.borrar(tipoDomicilio);

                Messagebox.show(
                        Labels.getLabel("editarTipoDomicilioController.MSG.borrarOK"),
                        Labels.getLabel("editarTipoDomicilioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoDomicilioList.removeItem(tipoDomicilio);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
